// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
impl super::Client {
    /// Constructs a fluent builder for the [`GetParallelData`](crate::operation::get_parallel_data::builders::GetParallelDataFluentBuilder) operation.
    ///
    /// - The fluent builder is configurable:
    ///   - [`name(impl Into<String>)`](crate::operation::get_parallel_data::builders::GetParallelDataFluentBuilder::name) / [`set_name(Option<String>)`](crate::operation::get_parallel_data::builders::GetParallelDataFluentBuilder::set_name):<br>required: **true**<br><p>The name of the parallel data resource that is being retrieved.</p><br>
    /// - On success, responds with [`GetParallelDataOutput`](crate::operation::get_parallel_data::GetParallelDataOutput) with field(s):
    ///   - [`parallel_data_properties(Option<ParallelDataProperties>)`](crate::operation::get_parallel_data::GetParallelDataOutput::parallel_data_properties): <p>The properties of the parallel data resource that is being retrieved.</p>
    ///   - [`data_location(Option<ParallelDataDataLocation>)`](crate::operation::get_parallel_data::GetParallelDataOutput::data_location): <p>The Amazon S3 location of the most recent parallel data input file that was successfully imported into Amazon Translate. The location is returned as a presigned URL that has a 30-minute expiration.</p><important>  <p>Amazon Translate doesn't scan all input files for the risk of CSV injection attacks.</p>  <p>CSV injection occurs when a .csv or .tsv file is altered so that a record contains malicious code. The record begins with a special character, such as =, +, -, or @. When the file is opened in a spreadsheet program, the program might interpret the record as a formula and run the code within it.</p>  <p>Before you download an input file from Amazon S3, ensure that you recognize the file and trust its creator.</p> </important>
    ///   - [`auxiliary_data_location(Option<ParallelDataDataLocation>)`](crate::operation::get_parallel_data::GetParallelDataOutput::auxiliary_data_location): <p>The Amazon S3 location of a file that provides any errors or warnings that were produced by your input file. This file was created when Amazon Translate attempted to create a parallel data resource. The location is returned as a presigned URL to that has a 30-minute expiration.</p>
    ///   - [`latest_update_attempt_auxiliary_data_location(Option<ParallelDataDataLocation>)`](crate::operation::get_parallel_data::GetParallelDataOutput::latest_update_attempt_auxiliary_data_location): <p>The Amazon S3 location of a file that provides any errors or warnings that were produced by your input file. This file was created when Amazon Translate attempted to update a parallel data resource. The location is returned as a presigned URL to that has a 30-minute expiration.</p>
    /// - On failure, responds with [`SdkError<GetParallelDataError>`](crate::operation::get_parallel_data::GetParallelDataError)
    pub fn get_parallel_data(&self) -> crate::operation::get_parallel_data::builders::GetParallelDataFluentBuilder {
        crate::operation::get_parallel_data::builders::GetParallelDataFluentBuilder::new(self.handle.clone())
    }
}
