// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct ListParallelDataOutput {
    /// <p>The properties of the parallel data resources returned by this request.</p>
    pub parallel_data_properties_list: ::std::option::Option<::std::vec::Vec<crate::types::ParallelDataProperties>>,
    /// <p>The string to use in a subsequent request to get the next page of results in a paginated response. This value is null if there are no additional pages.</p>
    pub next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl ListParallelDataOutput {
    /// <p>The properties of the parallel data resources returned by this request.</p>
    ///
    /// If no value was sent for this field, a default will be set. If you want to determine if no value was sent, use `.parallel_data_properties_list.is_none()`.
    pub fn parallel_data_properties_list(&self) -> &[crate::types::ParallelDataProperties] {
        self.parallel_data_properties_list.as_deref().unwrap_or_default()
    }
    /// <p>The string to use in a subsequent request to get the next page of results in a paginated response. This value is null if there are no additional pages.</p>
    pub fn next_token(&self) -> ::std::option::Option<&str> {
        self.next_token.as_deref()
    }
}
impl ::aws_types::request_id::RequestId for ListParallelDataOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl ListParallelDataOutput {
    /// Creates a new builder-style object to manufacture [`ListParallelDataOutput`](crate::operation::list_parallel_data::ListParallelDataOutput).
    pub fn builder() -> crate::operation::list_parallel_data::builders::ListParallelDataOutputBuilder {
        crate::operation::list_parallel_data::builders::ListParallelDataOutputBuilder::default()
    }
}

/// A builder for [`ListParallelDataOutput`](crate::operation::list_parallel_data::ListParallelDataOutput).
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
#[non_exhaustive]
pub struct ListParallelDataOutputBuilder {
    pub(crate) parallel_data_properties_list: ::std::option::Option<::std::vec::Vec<crate::types::ParallelDataProperties>>,
    pub(crate) next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl ListParallelDataOutputBuilder {
    /// Appends an item to `parallel_data_properties_list`.
    ///
    /// To override the contents of this collection use [`set_parallel_data_properties_list`](Self::set_parallel_data_properties_list).
    ///
    /// <p>The properties of the parallel data resources returned by this request.</p>
    pub fn parallel_data_properties_list(mut self, input: crate::types::ParallelDataProperties) -> Self {
        let mut v = self.parallel_data_properties_list.unwrap_or_default();
        v.push(input);
        self.parallel_data_properties_list = ::std::option::Option::Some(v);
        self
    }
    /// <p>The properties of the parallel data resources returned by this request.</p>
    pub fn set_parallel_data_properties_list(mut self, input: ::std::option::Option<::std::vec::Vec<crate::types::ParallelDataProperties>>) -> Self {
        self.parallel_data_properties_list = input;
        self
    }
    /// <p>The properties of the parallel data resources returned by this request.</p>
    pub fn get_parallel_data_properties_list(&self) -> &::std::option::Option<::std::vec::Vec<crate::types::ParallelDataProperties>> {
        &self.parallel_data_properties_list
    }
    /// <p>The string to use in a subsequent request to get the next page of results in a paginated response. This value is null if there are no additional pages.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.next_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The string to use in a subsequent request to get the next page of results in a paginated response. This value is null if there are no additional pages.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.next_token = input;
        self
    }
    /// <p>The string to use in a subsequent request to get the next page of results in a paginated response. This value is null if there are no additional pages.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.next_token
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`ListParallelDataOutput`](crate::operation::list_parallel_data::ListParallelDataOutput).
    pub fn build(self) -> crate::operation::list_parallel_data::ListParallelDataOutput {
        crate::operation::list_parallel_data::ListParallelDataOutput {
            parallel_data_properties_list: self.parallel_data_properties_list,
            next_token: self.next_token,
            _request_id: self._request_id,
        }
    }
}
