// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct ListTerminologiesOutput {
    /// <p>The properties list of the custom terminologies returned on the list request.</p>
    pub terminology_properties_list: ::std::option::Option<::std::vec::Vec<crate::types::TerminologyProperties>>,
    /// <p>If the response to the ListTerminologies was truncated, the NextToken fetches the next group of custom terminologies.</p>
    pub next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl ListTerminologiesOutput {
    /// <p>The properties list of the custom terminologies returned on the list request.</p>
    ///
    /// If no value was sent for this field, a default will be set. If you want to determine if no value was sent, use `.terminology_properties_list.is_none()`.
    pub fn terminology_properties_list(&self) -> &[crate::types::TerminologyProperties] {
        self.terminology_properties_list.as_deref().unwrap_or_default()
    }
    /// <p>If the response to the ListTerminologies was truncated, the NextToken fetches the next group of custom terminologies.</p>
    pub fn next_token(&self) -> ::std::option::Option<&str> {
        self.next_token.as_deref()
    }
}
impl ::aws_types::request_id::RequestId for ListTerminologiesOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl ListTerminologiesOutput {
    /// Creates a new builder-style object to manufacture [`ListTerminologiesOutput`](crate::operation::list_terminologies::ListTerminologiesOutput).
    pub fn builder() -> crate::operation::list_terminologies::builders::ListTerminologiesOutputBuilder {
        crate::operation::list_terminologies::builders::ListTerminologiesOutputBuilder::default()
    }
}

/// A builder for [`ListTerminologiesOutput`](crate::operation::list_terminologies::ListTerminologiesOutput).
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
#[non_exhaustive]
pub struct ListTerminologiesOutputBuilder {
    pub(crate) terminology_properties_list: ::std::option::Option<::std::vec::Vec<crate::types::TerminologyProperties>>,
    pub(crate) next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl ListTerminologiesOutputBuilder {
    /// Appends an item to `terminology_properties_list`.
    ///
    /// To override the contents of this collection use [`set_terminology_properties_list`](Self::set_terminology_properties_list).
    ///
    /// <p>The properties list of the custom terminologies returned on the list request.</p>
    pub fn terminology_properties_list(mut self, input: crate::types::TerminologyProperties) -> Self {
        let mut v = self.terminology_properties_list.unwrap_or_default();
        v.push(input);
        self.terminology_properties_list = ::std::option::Option::Some(v);
        self
    }
    /// <p>The properties list of the custom terminologies returned on the list request.</p>
    pub fn set_terminology_properties_list(mut self, input: ::std::option::Option<::std::vec::Vec<crate::types::TerminologyProperties>>) -> Self {
        self.terminology_properties_list = input;
        self
    }
    /// <p>The properties list of the custom terminologies returned on the list request.</p>
    pub fn get_terminology_properties_list(&self) -> &::std::option::Option<::std::vec::Vec<crate::types::TerminologyProperties>> {
        &self.terminology_properties_list
    }
    /// <p>If the response to the ListTerminologies was truncated, the NextToken fetches the next group of custom terminologies.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.next_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>If the response to the ListTerminologies was truncated, the NextToken fetches the next group of custom terminologies.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.next_token = input;
        self
    }
    /// <p>If the response to the ListTerminologies was truncated, the NextToken fetches the next group of custom terminologies.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.next_token
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`ListTerminologiesOutput`](crate::operation::list_terminologies::ListTerminologiesOutput).
    pub fn build(self) -> crate::operation::list_terminologies::ListTerminologiesOutput {
        crate::operation::list_terminologies::ListTerminologiesOutput {
            terminology_properties_list: self.terminology_properties_list,
            next_token: self.next_token,
            _request_id: self._request_id,
        }
    }
}
